%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% texstudio configuration
% pdflatex -synctex=1 --shell-escape -interaction=nonstopmode %.tex

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\def\mycmd{0} % 0 - print, 1 - pdf

% print configuration
\if\mycmd0
\documentclass[a4paper,12pt,hidelinks,twoside]{report}
\usepackage[bindingoffset = 1cm, hmargin = 2cm, vmargin = 2.5cm]{geometry}

% pdf configuration
\else
\documentclass[a4paper,12pt,hidelinks]{report}
\usepackage[hmargin = 2cm, vmargin = 2.5cm]{geometry}
\fi

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\usepackage[utf8]{inputenc} % allows the user to input accented 
                            % characters directly from the keyboard
\usepackage[T1]{fontenc}
\usepackage[polish, english]{babel}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\usepackage{indentfirst} % indent each paragraph
\frenchspacing % additional space after the sentence
\setlength{\parindent}{0.5cm} 
\raggedbottom % do not spread paragraphs out over a page

\usepackage{setspace} % vertical spacing
\renewcommand{\baselinestretch}{1.2} 

\usepackage{enumitem} % spaces in itemize, enumerate
\setlist{nosep}

\usepackage[protrusion=true, expansion, tracking=true, %
kerning=true, spacing=true]{microtype} % micro-typographic

\hyphenpenalty=100 % breaking words
\exhyphenpenalty=50 % breaking words already with -
\uchyph=0 % breaking words starting with capital letter
\doublehyphendemerits=500 % breaking words in subsequent lines
\lefthyphenmin=3 % minimal number of broken word's letters at the end of line
\righthyphenmin=3 % minimal number of broken word's letters at the beginning of line
\clubpenalty=1000 % no single line at the beginning of the page
\widowpenalty=1000 % no single line at the end of the page
\brokenpenalty=1000 % do not divide page if word is broken
\interfootnotelinepenalty=10000 % do not split footnotes between pages

\pretolerance=1
\tolerance=100

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% page style
\usepackage{fancyhdr}
\usepackage{emptypage} % pagestyle empty if page omitted 
% due to \cleardoublepage command

\fancypagestyle{empty}{
	\fancyhf{}
	\renewcommand{\headrulewidth}{0pt}
	\fancyfoot{}
}

% print configuration
\if\mycmd0
\fancypagestyle{plain}{
	\fancyhf{}
	\renewcommand{\headrulewidth}{0pt}
	\fancyfoot[LE,RO]{\thepage}
}
\fancypagestyle{headings}{
	\fancyhead{}
	\renewcommand{\headrulewidth}{1pt}
	\fancyheadoffset{0cm}
	\fancyhead[LE,RO]{\textit{\leftmark}}
	\fancyfoot{}
	\fancyfoot[LE,RO]{\thepage}
}

% pdf configuration
\else
\fancypagestyle{plain}{
	\fancyhf{}
	\renewcommand{\headrulewidth}{0pt}
	\fancyfoot{}
}
\fancypagestyle{headings}{
	\fancyhead{}
	\renewcommand{\headrulewidth}{1pt}
	\fancyheadoffset{0cm}
	\fancyhead[RO]{\textit{\leftmark}}
	\fancyfoot[C]{\thepage}
}
\fi

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\usepackage{nameref}
\usepackage{hyperref} % all cross-referenced elements become hyperlinked
\usepackage{xurl} % break long urls
\hypersetup{     
	urlcolor=blue, % links to web sites color
	bookmarks=true % adds navigation menu usually shown in left panel of the reader
}
\urlstyle{same} % no mono-style spacing for url

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\setcounter{tocdepth}{2} % table of contents depth
\usepackage[nottoc]{tocbibind} % put list of figures and 
                               % list of tables into table of contents

% kropki po numerach section i subsection w tekscie pracy
\usepackage{secdot} 
\sectiondot{section}
\sectiondot{subsection}
% modyfikacja spisu tresci
\usepackage{tocloft}
\renewcommand{\cftsecleader}{\cftdotfill{\cftdotsep}} % wykropkowanie miedzy tekstem a numerem strony
\renewcommand{\cftchapaftersnum}{.} % kropki po numerach section
\renewcommand{\cftsecaftersnum}{.} % kropki po numerach section
\renewcommand{\cftsubsecaftersnum}{.} % kropki po numerach subsection
\renewcommand{\cfttabaftersnum}{.} % kropki w spisie tabel
\renewcommand{\cftfigaftersnum}{.} % kropki w spisie rysunkow

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% graphics
\usepackage{float} % allows [H] figure placement
\usepackage{graphicx}
\usepackage{svg} % pdflatex -synctex=1 --shell-escape -interaction=nonstopmode
\usepackage[labelsep=period]{caption}
%.tex
\graphicspath{ {./pic/} }
\captionsetup[figure]{font=small}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% tables
\usepackage{array}
\usepackage{multirow}
\usepackage{longtable}
\usepackage{tablefootnote}
\usepackage[flushleft]{threeparttable}
\renewcommand{\arraystretch}{1.2}
\captionsetup[table]{font=small}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% bibtex
\usepackage[numbers,sort&compress,comma]{natbib}
\bibliographystyle{unsrtnat}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\usepackage[shortcuts,acronyms,automake]{glossaries-extra}
\setabbreviationstyle[acronym]{long-short}
\makeglossaries
% requires running makeglossaries command to compile

\newacronym{axi}{AXI}{Advanced eXtensible Interface}
\newacronym{bfht}{BFHT}{Basic Fast Hash Table}
\newacronym{bram}{BRAM}{Block RAM}
\newacronym{cam}{CAM}{content-addressable memory}
\newacronym{cern}{CERN}{European Organization for Nuclear Research}
\newacronym{cpu}{CPU}{central processing unit}
\newacronym{crc}{CRC}{cyclic redundancy check}
\newacronym{ddr}{DDR}{double data rate}
\newacronym{ddmtd}{DDMTD}{Digital Dual Mixer Time-Difference}
\newacronym{fcs}{FCS}{frame check sequence}
\newacronym{fddi}{FDDI}{Fiber Distributed Data Interface}
\newacronym{fht}{FHT}{Fast Hash Table}
\newacronym{fid}{FID}{Filtering~ID}
\newacronym{fifo}{FIFO}{first in, first out buffer}
\newacronym{fpga}{FPGA}{Field Programmable Gate Array}
\newacronym{gmrp}{GMRP}{GARP MAC Registration Protocol}
\newacronym{gmt}{GMT}{General Machine Timing}
\newacronym{gps}{GPS}{Global Positioning System}
\newacronym{gvrp}{GVRP}{GARP VLAN Registration Protocol}
\newacronym{hdl}{HDL}{hardware description language}
\newacronym{htab}{HTAB}{HASH~table}
\newacronym{ieee}{IEEE}{Institute of Electrical and Electronics Engineers}
\newacronym{ip}{IP}{intellectual property}
\newacronym{ipprot}{IP}{Internet Protocol}
\newacronym{l1}{L1}{Layer 1}
\newacronym{l2}{L2}{Layer 2}
\newacronym{l3}{L3}{Layer 3}
\newacronym{lan}{LAN}{Local Area Network}
\newacronym{lhc}{LHC}{Large Hadron Collider}
\newacronym{llc}{LLC}{logical link control}
\newacronym{mac}{MAC}{media access control}
\newacronym{mmrp}{MMRP}{Multiple MAC Registration Protocol}
\newacronym{mpps}{MPPS}{million packets per second}
\newacronym{mstp}{MSTP}{Multiple Spanning Tree Protocol}
\newacronym{mtab}{MTAB}{MAC~table}
\newacronym{mvrp}{MVRP}{Multiple VLAN Registration Protocol}
\newacronym{nic}{NIC}{network interface controller}
\newacronym{ntp}{NTP}{Network Time Protocol}
\newacronym{ohl}{OHL}{CERN Open Hardware Licence}
\newacronym{osi}{OSI}{Open Systems Interconnection}
\newacronym{pcb}{PCB}{printed circuit board}
\newacronym{pfht}{PFHT}{Pruned Fast Hash Table}
\newacronym{pl}{PL}{programmable logic}
\newacronym{ps}{PS}{Processing System}
\newacronym{ptp}{PTP}{Precision Time Protocol}
\newacronym{qos}{QoS}{quality of service}
\newacronym{ram}{RAM}{random-access memory}
\newacronym{rfc}{RFC}{Request for Comments}
\newacronym{rstp}{RSTP}{Rapid Spanning Tree Protocol}
\newacronym{rtu}{RTU}{Routing Table Unit}
\newacronym{sdn}{SDN}{Software Defined Networking}
\newacronym{sht}{SHT}{Segmented Hash Table}
\newacronym{sfht}{SFHT}{Shared-node Fast Hash Table}
\newacronym{soc}{SoC}{\mbox{system-on-chip}}
\newacronym{spb}{SPB}{Shortest Path Bridging}
\newacronym{tcam}{TCAM}{ternary CAM}
\newacronym{tcp}{TCP}{Transmission Control Protocol}
\newacronym{tru}{TRU}{Topology Resolution Unit}
\newacronym{tsn}{TSN}{\mbox{Time-Sensitive} Networking}
\newacronym{uram}{URAM}{UltraRAM}
\newacronym{utc}{UTC}{Coordinated Universal Time}
\newacronym{vid}{VID}{VLAN~ID}
\newacronym{vtab}{VTAB}{VLAN~table}
\newacronym{vlan}{VLAN}{Virtual Local Area Network}
\newacronym{wr}{WR}{White~Rabbit}
\newacronym{wrs}{WRS}{White~Rabbit Switch}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newcommand{\ignore}[1]{\ignorespaces} % inline comments

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% special symbols
\usepackage{pifont}
\newcommand{\cmark}{\ding{51}}
\newcommand{\xmark}{\ding{55}}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\usepackage[titletoc]{appendix}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\usepackage{pdfpages} 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{document} 

\pagestyle{empty}	
\nocite{*}

\includepdf[pages=-]{src_doc/tytulowa.pdf}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\cleardoublepage
\input{src_doc/0-summary-eng.tex}

\cleardoublepage
\input{src_doc/0-summary-pl.tex}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\cleardoublepage
\includepdf[pages=-]{src_doc/z_46_2016-pages-18-19.pdf}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\cleardoublepage

\begin{flushright}
	\vspace*{\fill}
	\begin{minipage}{0.5\textwidth}
		\begin{flushright}
		\textbf{Acknowledgements}\\
		\medskip
		Ph.D Grzegorz Kasprowicz\\
		Ph.D Maciej Lipiński\\
		\medskip
		\textit{Thank you for giving me the opportunity\\ to participate in the White Rabbit Switch project and for all your support and feedback.}
	    \end{flushright}
	\end{minipage}
\end{flushright}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\cleardoublepage
\pagestyle{empty}
{
	\renewcommand{\thispagestyle}[1]{}
	\tableofcontents
}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\cleardoublepage
\pagestyle{headings}

\cleardoublepage
\chapter{Introduction}
\label{introduction}
\input{src_doc/1-introduction.tex}

\cleardoublepage
\chapter{Theoretical Background}
\label{background}
\input{src_doc/2-theoretical-background.tex}

\cleardoublepage
\chapter{White Rabbit Switch}
\label{ch:wrs}
\input{src_doc/3-white-rabbit-switch.tex}

\cleardoublepage
\chapter{Aim and Scope of the Thesis}
\label{aim}
\input{src_doc/4-aim-scope-thesis.tex}

\cleardoublepage
\chapter{State of the Art}
\label{state-of-art}
\input{src_doc/5-state-of-art.tex}

\cleardoublepage
\chapter{Filtering Database -- Implementation}
\label{fib-implementation}
\input{src_doc/6-filtering-database.tex}

\cleardoublepage
\chapter{Forwarding Engine -- Implementation}
\label{engine-implementation}
\input{src_doc/7-forwarding-engine.tex}

\cleardoublepage
\chapter{Test and Verification}
\label{test-verification}
\input{src_doc/8-test-verification.tex}

\cleardoublepage
\chapter{Conclusions}
\label{conclusions}
\input{src_doc/9-conclusions.tex}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\cleardoublepage
\pagestyle{plain}

\bibliography{bibliography/bibliography.bib}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newpage
\printglossary[title=List of Acronyms, type=\acronymtype]

\newpage
\listoffigures

\newpage
\listoftables

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{appendices}
	
\newpage	
\chapter{Forwarding Engine Configuration and Interfaces}
\label{forwarding-engine-configuration}
\input{src_doc/10-forwarding-engine-configuration.tex}

\newpage
\chapter{Filtering Database Entries}
\label{filtering-database-entries}
\input{src_doc/11-filtering-database-entries.tex}

\end{appendices}

\end{document}